"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const anchor_1 = require("@coral-xyz/anchor");
const web3_js_1 = require("@solana/web3.js");
const fs_1 = __importDefault(require("fs"));
const client_1 = require("../../src/client");
const constants_1 = require("../../src/constants");
const router_1 = require("../../src/router");
const CLUSTER = process.env.CLUSTER_OVERRIDE || 'mainnet-beta';
const CLUSTER_URL = process.env.CLUSTER_URL_OVERRIDE || process.env.MB_CLUSTER_URL;
const USER_KEYPAIR = process.env.USER_KEYPAIR_OVERRIDE || process.env.MB_PAYER_KEYPAIR;
const MANGO_ACCOUNT_PK = process.env.MANGO_ACCOUNT_PK;
const usdcMint = new web3_js_1.PublicKey('EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v');
const wsolMint = new web3_js_1.PublicKey('So11111111111111111111111111111111111111112');
async function x() {
    const options = anchor_1.AnchorProvider.defaultOptions();
    const connection = new web3_js_1.Connection(CLUSTER_URL, options);
    const user = web3_js_1.Keypair.fromSecretKey(Buffer.from(JSON.parse(process.env.KEYPAIR || fs_1.default.readFileSync(USER_KEYPAIR, 'utf-8'))));
    const userWallet = new anchor_1.Wallet(user);
    const userProvider = new anchor_1.AnchorProvider(connection, userWallet, options);
    const client = await client_1.MangoClient.connect(userProvider, CLUSTER, constants_1.MANGO_V4_ID[CLUSTER], {
        idsSource: 'get-program-accounts',
    });
    const group = await client.getGroup(new web3_js_1.PublicKey('AKeMSYiJekyKfwCc3CUfVNDVAiqk9FfbQVMY3G7RUZUf'));
    const { bestRoute } = await (0, router_1.fetchRoutes)(usdcMint, wsolMint, '1', undefined, undefined, undefined, user.publicKey);
    const [ixs, alts] = bestRoute.routerName === 'Mango'
        ? await (0, router_1.prepareMangoRouterInstructions)(bestRoute, usdcMint, wsolMint, user.publicKey)
        : await (0, router_1.fetchJupiterTransaction)(client.connection, bestRoute, user.publicKey, 0, usdcMint, wsolMint);
    try {
        console.log('hi');
        const sig = await client.marginTrade({
            group: group,
            mangoAccount: await client.getMangoAccount(new web3_js_1.PublicKey(MANGO_ACCOUNT_PK)),
            inputMintPk: usdcMint,
            amountIn: 1,
            outputMintPk: wsolMint,
            userDefinedInstructions: ixs,
            userDefinedAlts: alts,
            flashLoanType: { swap: {} },
        });
        console.log('hi');
        console.log(` - marginTrade, sig https://explorer.solana.com/tx/${sig}?cluster=${CLUSTER == 'devnet' ? 'devnet' : ''}`);
    }
    catch (error) {
        console.log(error);
    }
}
x();
