"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const web3_js_1 = require("@solana/web3.js");
const client_1 = require("../src/client");
const utils_1 = require("../src/utils");
async function run() {
    const client = await client_1.MangoClient.connectDefault(process.env.MB_CLUSTER_URL);
    let group = await client.getGroup(new web3_js_1.PublicKey('AKeMSYiJekyKfwCc3CUfVNDVAiqk9FfbQVMY3G7RUZUf'));
    let accounts = await client.getAllMangoAccounts(group, true);
    const jitoBank = group.getFirstBankByMint(new web3_js_1.PublicKey('J1toso1uCk3RLmjorhTtrVwY9HJ7X8V9yYac6Y7kGCPn'));
    const jitoSpotMarket = group.getSerum3MarketByName('JitoSOL/USDC');
    accounts = accounts.filter((a) => a.getTokenBalanceUi(jitoBank) +
        (a.getSerum3Account(jitoSpotMarket.marketIndex)
            ? a
                .getSerum3OoAccount(jitoSpotMarket.marketIndex)
                .baseTokenTotal.toNumber()
            : 0) >
        0.1);
    accounts.sort((a, b) => a.publicKey.toBase58().localeCompare(b.publicKey.toBase58()));
    console.log(`wallet,mango_account,jito_sol_balance_ui`);
    accounts.forEach((a) => console.log(`${a.owner},${a.publicKey},${a.getTokenBalanceUi(jitoBank) +
        (a.getSerum3Account(jitoSpotMarket.marketIndex)
            ? (0, utils_1.toUiDecimals)(a
                .getSerum3OoAccount(jitoSpotMarket.marketIndex)
                .baseTokenTotal.toNumber(), jitoBank.mintDecimals)
            : 0)}`));
}
run();
