"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const anchor_1 = require("@coral-xyz/anchor");
const web3_js_1 = require("@solana/web3.js");
const dotenv = __importStar(require("dotenv"));
const client_1 = require("../src/client");
const constants_1 = require("../src/constants");
const utils_1 = require("../src/utils");
dotenv.config();
const CLUSTER_URL = process.env.CLUSTER_URL_OVERRIDE || process.env.MB_CLUSTER_URL;
const GROUP_PK = process.env.GROUP_PK || 'AKeMSYiJekyKfwCc3CUfVNDVAiqk9FfbQVMY3G7RUZUf';
const CLUSTER = process.env.CLUSTER_OVERRIDE || 'mainnet-beta';
async function main() {
    const options = anchor_1.AnchorProvider.defaultOptions();
    const connection = new web3_js_1.Connection(CLUSTER_URL, options);
    const wallet = new anchor_1.Wallet(new web3_js_1.Keypair());
    const provider = new anchor_1.AnchorProvider(connection, wallet, options);
    const client = client_1.MangoClient.connect(provider, CLUSTER, constants_1.MANGO_V4_ID[CLUSTER], {
        idsSource: 'get-program-accounts',
    });
    const group = await client.getGroup(new web3_js_1.PublicKey(GROUP_PK));
    const mangoAccounts = await client.getAllMangoAccounts(group, true);
    Array.from(group.perpMarketsMapByMarketIndex.values())
        .filter((perpMarket) => perpMarket.name != 'SOMETHING-PERP')
        .map((perpMarket) => {
        console.log(`name ${perpMarket.name}`);
        let getUnsettledPnlUiAgg = 0;
        let getBasePositionUiAgg = 0;
        let getQuotePositionUiAgg = 0;
        let longSettledFundingAgg = 0;
        let shortSettledFundingAgg = 0;
        mangoAccounts.map((mangoAccount) => {
            const pp = mangoAccount
                .perpActive()
                .find((pp) => pp.marketIndex === perpMarket.perpMarketIndex);
            if (pp) {
                getUnsettledPnlUiAgg +=
                    pp.getUnsettledPnlUi(perpMarket) -
                        pp.getUnsettledFundingUi(perpMarket);
                getBasePositionUiAgg += pp.getBasePositionUi(perpMarket);
                getQuotePositionUiAgg += pp.getQuotePositionUi(perpMarket);
                longSettledFundingAgg += pp.longSettledFunding.toNumber();
                shortSettledFundingAgg += pp.shortSettledFunding.toNumber();
            }
        });
        // console.log(
        //   `- longSettledFundingAgg - shortSettledFunding ${(
        //     longSettledFundingAgg - shortSettledFundingAgg
        //   )
        //     .toFixed(4)
        //     .padStart(10)}`,
        // );
        // console.log(
        //   `- unsettled pnl aggr ${getUnsettledPnlUiAgg.toFixed(4).padStart(10)}`,
        // );
        // console.log(
        //   `- base position aggr ${getBasePositionUiAgg.toFixed(4).padStart(10)}`,
        // );
        // console.log(
        //   `- quote position aggr ${getQuotePositionUiAgg
        //     .toFixed(4)
        //     .padStart(10)}`,
        // );
        // console.log(
        //   `- base position aggr * price ${(
        //     getBasePositionUiAgg * perpMarket.uiPrice
        //   )
        //     .toFixed(4)
        //     .padStart(10)}`,
        // );
        // console.log(
        //   `- perp.feesAccrued ${toUiDecimalsForQuote(perpMarket.feesAccrued)}`,
        // );
        // console.log(
        //   `- unsettled pnl aggr - base position aggr * price ${(
        //     getUnsettledPnlUiAgg -
        //     getBasePositionUiAgg * perpMarket.uiPrice
        //   )
        //     .toFixed(4)
        //     .padStart(10)}`,
        // );
        console.log(`- perp.feesAccrued  + unsettled pnl aggr ${(0, utils_1.toUiDecimalsForQuote)(perpMarket.feesAccrued) + getUnsettledPnlUiAgg}`);
    });
    process.exit();
}
try {
    main();
}
catch (error) {
    console.log(error);
}
